<?php
/**
 * ------------------------------------------------------------------------
 * JA Filter Plugin - Eshop
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
if (file_exists(JPATH_ROOT.'/components/com_eshop/helpers/route.php') && !class_exists('EshopRoute'))
	require_once(JPATH_ROOT.'/components/com_eshop/helpers/route.php');
JHtml::script('components/com_eshop/assets/js/noconflict.js');
JHtml::script('components/com_eshop/assets/js/eshop.js');
JHtml::script('components/com_eshop/assets/colorbox/jquery.colorbox.js');
JHtml::stylesheet('components/com_eshop/assets/colorbox/colorbox.css');
JHtml::stylesheet('components/com_eshop/assets/css/labels.css');

function getProductQuantity($pIds) {
	$db = JFactory::getDbo();
	$query = $db->getQuery(true);
	$query->select('id, product_quantity')
		->from('#__eshop_products AS a')
		->where('a.id IN (' . implode(',', $pIds) . ')');
	$db->setQuery($query);
	$rows = $db->loadObjectList();
	$array = array();
	foreach ($rows AS $row) {
		$array[$row->id] = $row->product_quantity;
	}
	return $array;
}

$input = JFactory::getApplication()->input;
$shopper_groups = array(0);
$user = JFactory::getUser();
$currency = new EshopCurrency();
if ($user->get('id'))
{
	$customer = new EshopCustomer();
	$customerGroupId = $customer->getCustomerGroupId();
	$shopper_groups = array($customerGroupId);
}

$json = file_get_contents(JPATH_SITE.$this->config->json);
$array = (array) json_decode($json);
$sefUrl = array();
$discount = array();
$productID = array();
$quantities = array();
foreach ( $array as $value)
{
	$sefUrl[$value->id] = JROUTE::_(EshopRoute::getProductRoute($value->id, $value->maincat));
	if ((int)EshopHelper::getDiscountPrice($value->id) != 0)
		$discount[$value->id] = $currency->format(EshopHelper::getDiscountPrice($value->id));
	$productID[] = $value->id;
}
$quantities = getProductQuantity($productID);
?>
<div class="row eshop ja-megafilter-wrap clearfix">
  <div class="ja-mg-sidebar sidebar-main col">
    <div class="block ub-layered-navigation-sidebar sidebar-content">    
    </div>
  </div>

  <div class="main-content col">    
  </div>

</div>

<script type="text/javascript">
var JABaseUrl = '<?php echo JUri::base(true); ?>';
var BaseUrl = '<?php echo JUri::base(); ?>';
var sefUrl = <?php echo json_encode($sefUrl) ?>;
var discount = <?php echo json_encode($discount); ?>;
var quantities = <?php echo json_encode($quantities); ?>;
var shopper_groups = <?php echo json_encode($shopper_groups) ?>;

var p = <?php echo json_encode($this->jstemplate); ?>;
for (var key in p) {
  if (p.hasOwnProperty(key)) {
    var compiled = dust.compile(p[key], key);
    dust.loadSource(compiled);
  }
}

function bindCallback() {
	setTimeout(function(){
		jQuery('.quantity-controls.quantity-plus, .quantity-controls.quantity-minus').off().unbind().on('click' ,function(){
			$val = jQuery(this).parents('div.addtocart-bar').find('input.quantity-input').val();
			$val = parseInt($val);
			if (jQuery(this).hasClass('quantity-plus'))
				$val++;
			else $val--;
			if ($val<1) $val=1;
			jQuery(this).parents('div.addtocart-bar').find('input.quantity-input').val($val);
		});
		if (jQuery('.jamegafilter-wrapper').find('.pagination-wrap').length) {
			jQuery('.jamegafilter-wrapper').removeClass('no-pagination');
		} else {
			jQuery('.jamegafilter-wrapper').addClass('no-pagination');
		}
		
		if (isMobile.apple.tablet && jQuery('#t3-off-canvas-sidebar').length) {
			jQuery('select').unbind().off().on('touchstart', function() {
    			formTouch=true;
    			fixedElement.css('position', 'absolute');
    			fixedElement.css('top', jQuery(document).scrollTop());
			});
			jQuery('html').unbind().off().on('touchmove', function() {
				if (formTouch==true) {
					fixedElement.css('position', 'fixed');
					fixedElement.css('top', '0');
					formTouch=false;
				}
			});
		}
	  }, 1000);
	if (jQuery('.items.product-items').find('.item').length == 0) {
		jQuery('.toolbar-amount').each(function(){
			jQuery(this).find('.toolbar-number').first().text(0);
		});
	}
}

function scrolltop() {
	if (!isMobile.phone) jQuery("html, body").stop().animate({ scrollTop: 0 }, 400);
}

function MegaFilterCallback() {
	bindCallback();
	<?php echo $input->getCmd('scrolltop') ? 'scrolltop();':'' ?>
}


function afterGetData(item) {
	item.url = sefUrl[item.id];
	if (discount[item.id] != undefined)
		item.frontend_price = discount[item.id];
	if (quantities[item.id] <= 0)
		item.is_salable = false;
	if ( item['shopper_groups'].length !== 0 ) {
		var common = jQuery.grep(shopper_groups, function(element) {
			return jQuery.inArray(element, item['shopper_groups'] ) !== -1;
		});
		
		if (common.length !== 0 ) {
			return false;
		} else {
			return true;
		}
	} else {
		return false;
	}
}

jQuery(document).ready(function() {
  var UBLNConfig = {};
  UBLNConfig.dataUrl = "<?php echo JUri::base(true).$this->config->json;  ?>";
  UBLNConfig.fields = <?php echo json_encode($this->config->fields); ?>;
  UBLNConfig.sortByOptions = <?php echo json_encode($this->config->sorts); ?>;
  UBLNConfig.defaultSortBy = "position";
  UBLNConfig.productsPerPageAllowed = [<?php echo implode(',', $this->config->paginate); ?>];
  UBLNConfig.autopage = <?php echo $this->config->autopage ? 'true':'false' ?>;
  UBLNConfig.sticky = <?php echo $this->config->sticky ? 'true':'false' ?>;
  UBLN.main(UBLNConfig);
  MegaFilterCallback();
});
</script>